## openssh 6.1p1

=== debian/changelog ===
openssh (1:6.1p1-3) experimental; urgency=low

  * Give ssh and ssh-krb5 versioned dependencies on openssh-client and
    openssh-server, to try to reduce confusion when people run 'apt-get
    install ssh' or similar and expect that to upgrade everything relevant.
  * CVE-2010-5107: Improve DoS resistance by changing default of MaxStartups
    to 10:30:100 (closes: #700102).

 -- Colin Watson <cjwatson@debian.org>  Fri, 08 Feb 2013 21:07:31 +0000

openssh (1:6.1p1-2) experimental; urgency=low

  * Use xz compression for binary packages.
  * Merge from Ubuntu:
    - Add support for registering ConsoleKit sessions on login.  (This is
      currently enabled only when building for Ubuntu.)
    - Drop openssh-blacklist and openssh-blacklist-extra to Suggests.  It's
      been long enough since the relevant vulnerability that we shouldn't
      need these installed by default nowadays.
    - Add an Upstart job (not currently used by default in Debian).
    - Add mention of ssh-keygen in ssh connect warning (Scott Moser).
    - Install apport hooks.
  * Only build with -j if DEB_BUILD_OPTIONS=parallel=* is used (closes:
    #694282).

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Nov 2012 16:39:07 +0000

openssh (1:6.1p1-1) experimental; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-6.1).
    - Enable pre-auth sandboxing by default for new installs.
    - Allow "PermitOpen none" to refuse all port-forwarding requests
      (closes: #543683).

 -- Colin Watson <cjwatson@debian.org>  Fri, 07 Sep 2012 00:22:44 +0100

=== debian/control ===
Source: openssh
Section: net
Priority: standard
Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
Build-Depends: libwrap0-dev | libwrap-dev, zlib1g-dev (>= 1:1.2.3-1), libssl-dev (>= 0.9.8g), libpam0g-dev | libpam-dev, libgtk2.0-dev, libedit-dev, debhelper (>= 7.4.2~), libselinux1-dev [linux-any], libkrb5-dev | heimdal-dev, dpkg (>= 1.16.1~), libck-connector-dev
Standards-Version: 3.8.4
Uploaders: Colin Watson <cjwatson@debian.org>, Matthew Vernon <matthew@debian.org>
Homepage: http://www.openssh.org/
Vcs-Bzr: http://anonscm.debian.org/bzr/pkg-ssh/openssh/trunk
Vcs-Browser: http://anonscm.debian.org/loggerhead/pkg-ssh/openssh/trunk

Package: openssh-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 1.2.0) | debconf-2.0, adduser (>= 3.10), dpkg (>= 1.7.0), passwd
Recommends: xauth
Conflicts: ssh (<< 1:3.8.1p1-9), sftp, rsh-client (<<0.16.1-1), ssh-krb5 (<< 1:4.3p2-7)
Replaces: ssh, ssh-krb5
Suggests: ssh-askpass, libpam-ssh, keychain, monkeysphere, openssh-blacklist, openssh-blacklist-extra
Provides: rsh-client, ssh-client
Multi-Arch: foreign
Description: secure shell (SSH) client, for secure access to remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the ssh, scp and sftp clients, the ssh-agent
 and ssh-add programs to make public key authentication more convenient,
 and the ssh-keygen, ssh-keyscan, ssh-copy-id and ssh-argv0 utilities.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 ssh replaces the insecure rsh, rcp and rlogin programs, which are
 obsolete for most purposes.

Package: openssh-server
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 1.2.0) | debconf-2.0, libpam-runtime (>= 0.76-14), libpam-modules (>= 0.72-9), adduser (>= 3.9), dpkg (>= 1.9.0), openssh-client (= ${binary:Version}), lsb-base (>= 3.2-13), procps, debianutils (>= 4)
Recommends: xauth, ncurses-term, ${openssh-server:Recommends}
Conflicts: ssh (<< 1:3.8.1p1-9), ssh-nonfree (<<2), ssh-socks, ssh2, sftp, rsh-client (<<0.16.1-1), ssh-krb5 (<< 1:4.3p2-7)
Replaces: ssh, openssh-client (<< 1:3.8.1p1-11), ssh-krb5
Suggests: ssh-askpass, rssh, molly-guard, ufw, monkeysphere, openssh-blacklist, openssh-blacklist-extra
Provides: ssh-server
Multi-Arch: foreign
Description: secure shell (SSH) server, for secure access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the sshd server.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 sshd replaces the insecure rshd program, which is obsolete for most
 purposes.

Package: ssh
Priority: extra
Architecture: all
Depends: ${misc:Depends}, openssh-client (>= ${binary:Version}), openssh-server (>= ${binary:Version})
Description: secure shell client and server (metapackage)
 This metapackage is a convenient way to install both the OpenSSH client
 and the OpenSSH server. It provides nothing in and of itself, so you
 may remove it if nothing depends on it.

Package: ssh-krb5
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends}, openssh-client (>= ${binary:Version}), openssh-server (>= ${binary:Version})
Description: secure shell client and server (transitional package)
 This is a transitional package depending on the regular Debian OpenSSH
 client and server, which now support GSSAPI natively. It will add the
 necessary GSSAPI options to the server configuration file. You can
 remove it once the upgrade is complete and nothing depends on it.

Package: ssh-askpass-gnome
Section: gnome
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssh-client | ssh (>= 1:1.2pre7-4) | ssh-krb5
Replaces: ssh (<< 1:3.5p1-3)
Provides: ssh-askpass
Description: interactive X program to prompt users for a passphrase for ssh-add
 This has been split out of the main openssh-client package so that
 openssh-client does not need to depend on GTK+.
 .
 You probably want the ssh-askpass package instead, but this is
 provided to add to your choice and/or confusion.

Package: openssh-client-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, libnss-files-udeb
XB-Installer-Menu-Item: 99999
Description: secure shell client for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the ssh client for use in debian-installer.

Package: openssh-server-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, libnss-files-udeb
Description: secure shell server for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the sshd server for use in debian-installer.
 Since it is expected to be used in specialized situations (e.g. S/390
 installs with no console), it does not provide any configuration.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUN_TESTS := yes
else
  RUN_TESTS :=
endif

ifeq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  PARALLEL :=
else
  PARALLEL := \
	-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CC := gcc
  PKG_CONFIG = pkg-config
else
  CC := $(DEB_HOST_GNU_TYPE)-gcc
  PKG_CONFIG = $(DEB_HOST_GNU_TYPE)-pkg-config
  RUN_TESTS :=
endif

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

# Take account of old dpkg-architecture output.
ifeq ($(DEB_HOST_ARCH_OS),)
  DEB_HOST_ARCH_OS := $(subst -gnu,,$(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM))
  ifeq ($(DEB_HOST_ARCH_OS),gnu)
    DEB_HOST_ARCH_OS := hurd
  endif
endif

# Change the version string to include the Debian version
SSH_EXTRAVERSION := Debian-$(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/Version: //p' | sed -e 's/[^-]*-//')

DISTRIBUTOR := $(shell if dpkg-vendor --derives-from Ubuntu 2>/dev/null; then echo Ubuntu; else echo Debian; fi)
ifeq ($(DISTRIBUTOR),Ubuntu)
DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11:/usr/games
else
DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/bin/X11:/usr/games
endif
SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11

ifeq ($(DISTRIBUTOR),Ubuntu)
server_recommends := ssh-import-id
else
server_recommends :=
endif

# Common path configuration.
confflags += --sysconfdir=/etc/ssh

# Common build options.
confflags += --disable-strip
confflags += --with-mantype=doc
confflags += --with-4in6
confflags += --with-privsep-path=/var/run/sshd

# The Hurd needs libcrypt for res_query et al.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
confflags += --with-libs=-lcrypt
endif

# Everything above here is common to the deb and udeb builds.
confflags_udeb := $(confflags)

# Options specific to the deb build.
confflags += --with-tcp-wrappers
confflags += --with-pam
confflags += --with-libedit
confflags += --with-kerberos5=/usr
confflags += --with-ssl-engine
ifeq ($(DEB_HOST_ARCH_OS),linux)
confflags += --with-selinux
endif
ifeq ($(DISTRIBUTOR),Ubuntu)
confflags += --with-consolekit
endif

# The deb build wants xauth; the udeb build doesn't.
confflags += --with-xauth=/usr/bin/xauth
confflags_udeb += --without-xauth

# Default paths. The udeb build has /usr/bin/X11 and /usr/games removed.
confflags += --with-default-path=$(DEFAULT_PATH) --with-superuser-path=$(SUPERUSER_PATH)
confflags_udeb += --with-default-path=/usr/local/bin:/usr/bin:/bin --with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# Compiler flags.
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
default_cflags := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
cflags := $(default_cflags)
cflags += -DLOGIN_PROGRAM=\"/bin/login\" -DLOGIN_NO_ENDOPT
cflags += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
cflags_udeb := -Os
cflags_udeb += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
confflags += --with-cflags='$(cflags)'
confflags_udeb += --with-cflags='$(cflags_udeb)'

# Linker flags.
default_ldflags := $(shell dpkg-buildflags --get LDFLAGS)
confflags += --with-ldflags='$(strip -Wl,--as-needed $(default_ldflags))'
confflags_udeb += --with-ldflags='-Wl,--as-needed'

%:
	dh $@

DISTRIBUTOR_REPLACE := \
	debian/openssh-server.if-up \
	debian/openssh-server.ssh.init \
	debian/openssh-server.postinst \
	debian/openssh-server.prerm \
	debian/ssh-krb5.postinst

debian/%: debian/%.in
	sed 's/@DISTRIBUTOR@/$(DISTRIBUTOR)/g' $< >$@

override_dh_auto_configure:
	dh_auto_configure -Bbuild-deb -- $(confflags)
	dh_auto_configure -Bbuild-udeb -- $(confflags_udeb)

override_dh_auto_build:
	# Debian's /var/log/btmp has inappropriate permissions.
	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' build-deb/config.h
	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' build-udeb/config.h

	# Avoid libnsl linkage. Ugh.
	perl -pi -e 's/ +-lnsl//' build-udeb/config.status
	cd build-udeb && ./config.status

	$(MAKE) -C build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
	$(MAKE) -C build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen

	$(MAKE) -C contrib gnome-ssh-askpass2 CC='$(CC) $(default_cflags) -Wall -Wl,--as-needed $(default_ldflags)' PKG_CONFIG=$(PKG_CONFIG)

override_dh_auto_test:
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/tests
endif

override_dh_auto_clean:
	rm -rf build-deb build-udeb
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/tests clean
endif
	$(MAKE) -C contrib clean
	(cat debian/copyright.head; iconv -f ISO-8859-1 -t UTF-8 LICENCE) \
		> debian/copyright

override_dh_clean:
	dh_clean
	rm -f $(DISTRIBUTOR_REPLACE)

override_dh_auto_install:
	$(MAKE) -C build-deb DESTDIR=`pwd`/debian/tmp install-nokeys

override_dh_install: $(DISTRIBUTOR_REPLACE)
	rm -f debian/tmp/etc/ssh/sshd_config

	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb --fail-missing
	dh_install -popenssh-client-udeb -popenssh-server-udeb \
		--sourcedir=build-udeb

	install -o root -g root -m 755 contrib/gnome-ssh-askpass2 debian/ssh-askpass-gnome/usr/lib/openssh/gnome-ssh-askpass

	install -o root -g root debian/openssh-server.if-up debian/openssh-server/etc/network/if-up.d/openssh-server
	install -o root -g root -m 644 debian/openssh-server.ufw.profile debian/openssh-server/etc/ufw/applications.d/openssh-server

	# Remove version control tags to avoid unnecessary conffile
	# resolution steps for administrators.
	sed -i '/\$$OpenBSD:/d' \
		debian/openssh-client/etc/ssh/moduli \
		debian/openssh-client/etc/ssh/ssh_config

	# dh_apport would be neater, but at the time of writing it isn't in
	# unstable yet.
	install -p -m 644 debian/openssh-client.apport debian/openssh-client/usr/share/apport/package-hooks/openssh-client.py
	install -p -m 644 debian/openssh-server.apport debian/openssh-server/usr/share/apport/package-hooks/openssh-server.py

override_dh_installdocs:
	dh_installdocs -Nopenssh-server -Nssh
	dh_installdocs -popenssh-server -pssh --link-doc=openssh-client
	# Avoid breaking dh_installexamples later.
	mkdir -p debian/openssh-server/usr/share/doc/openssh-client

override_dh_installinit:
	dh_installinit -n --name ssh
ifeq ($(DISTRIBUTOR),Ubuntu)
	# We need to keep the init script as well as the Upstart job for
	# now, for the benefit of people running sshd in chroots.
	install -D -o root -g root debian/openssh-server.ssh.init debian/openssh-server/etc/init.d/ssh
	install -D -o root -g root -m 644 debian/openssh-server.ssh.default debian/openssh-server/etc/default/ssh
endif

override_dh_installpam:
	dh_installpam --name sshd

override_dh_fixperms:
	dh_fixperms
	chmod u+s debian/openssh-client/usr/lib/openssh/ssh-keysign

# Tighten libssl dependencies to match the check in entropy.c.
override_dh_shlibdeps:
	dh_shlibdeps
	debian/adjust-openssl-dependencies

override_dh_installdeb: $(DISTRIBUTOR_REPLACE)
	dh_installdeb
	perl -i debian/substitute-conffile.pl \
		ETC_SSH_MODULI debian/openssh-client/etc/ssh/moduli \
		ETC_SSH_SSH_CONFIG debian/openssh-client/etc/ssh/ssh_config \
		debian/openssh-client/DEBIAN/preinst
	# Yes, ETC_PAM_D_SSH is meant to be spelled that way, to match the
	# old configuration file name we need to transfer.
	perl -i debian/substitute-conffile.pl \
		ETC_DEFAULT_SSH debian/openssh-server/etc/default/ssh \
		ETC_INIT_D_SSH debian/openssh-server/etc/init.d/ssh \
		ETC_PAM_D_SSH debian/openssh-server/etc/pam.d/sshd \
		debian/openssh-server/DEBIAN/preinst

override_dh_gencontrol:
	dh_gencontrol -- -V'openssh-server:Recommends=$(server_recommends)'

override_dh_builddeb:
	dh_builddeb -Zxz

## openssh 6.2p2

=== debian/changelog ===
openssh (1:6.2p2-6ubuntu0.5) saucy; urgency=medium

  * Force ssh-agent Upstart job to use sh syntax regardless of the user's
    shell (thanks, Steffen Stempel; LP: #1312928).

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 02 May 2014 09:53:07 +0100

openssh (1:6.2p2-6ubuntu0.4) saucy; urgency=medium

  * Re-enable btmp logging, as its permissions were fixed a long time ago.
    Backport from Debian and Trusty. (LP: #743858)

 -- Louis Bouchard <louis.bouchard@ubuntu.com>  Tue, 22 Apr 2014 09:52:59 -0500

openssh (1:6.2p2-6ubuntu0.3) saucy-security; urgency=medium

  * SECURITY UPDATE: failure to check SSHFP records if server presents a
    certificate
    - debian/patches/CVE-2014-2653.patch: fix logic in sshconnect.c.
    - CVE-2014-2653

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 07 Apr 2014 09:32:06 -0400

openssh (1:6.2p2-6ubuntu0.2) saucy-security; urgency=medium

  * SECURITY UPDATE: AcceptEnv wildcard environment restrictions bypass
    - debian/patches/CVE-2014-2532.patch: don't allow invalid chars in
      session.c.
    - CVE-2014-2532

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 21 Mar 2014 10:58:07 -0400

openssh (1:6.2p2-6ubuntu0.1) saucy-security; urgency=low

  * SECURITY UPDATE: code execution via memory corruption when using an
    AES-GCM cipher
    - debian/patches/CVE-2013-4548.patch: properly initialize MAC context
      in monitor_wrap.c.
    - CVE-2013-4548

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 08 Nov 2013 07:55:17 -0500

openssh (1:6.2p2-6) unstable; urgency=low

  * Update config.guess and config.sub automatically at build time.
    dh_autoreconf does not take care of that by default because openssh does
    not use automake.

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 Jul 2013 22:54:49 +0100

openssh (1:6.2p2-5) unstable; urgency=low

  [ Colin Watson ]
  * Document consequences of ssh-agent being setgid in ssh-agent(1); see
    #711623.
  * Use 'set -e' rather than '#! /bin/sh -e' in maintainer scripts and
    ssh-argv0.

  [ Yolanda Robla ]
  * debian/rules: Include real distribution in SSH_EXTRAVERSION instead of
    hardcoding Debian (LP: #1195342).

 -- Colin Watson <cjwatson@debian.org>  Thu, 27 Jun 2013 15:24:14 +0100

openssh (1:6.2p2-4) unstable; urgency=low

  * Fix non-portable shell in ssh-copy-id (closes: #711162).
  * Rebuild against debhelper 9.20130604 with fixed dependencies for
    invoke-rc.d and Upstart jobs (closes: #711159, #711364).
  * Set SELinux context on private host keys as well as public host keys
    (closes: #687436).

 -- Colin Watson <cjwatson@debian.org>  Thu, 06 Jun 2013 17:06:31 +0100

openssh (1:6.2p2-3) unstable; urgency=low

  * If the running init daemon is Upstart, then, on the first upgrade to
    this version, check whether sysvinit is still managing sshd; if so,
    manually stop it so that it can be restarted under upstart.  We do this
    near the end of the postinst, so it shouldn't result in any appreciable
    extra window where sshd is not running during upgrade.

 -- Colin Watson <cjwatson@debian.org>  Wed, 22 May 2013 17:42:10 +0100

openssh (1:6.2p2-2) unstable; urgency=low

  * Change start condition of Upstart job to be just the standard "runlevel
    [2345]", rather than "filesystem or runlevel [2345]"; the latter makes
    it unreasonably difficult to ensure that urandom starts before ssh, and
    is not really necessary since one of static-network-up and failsafe-boot
    is guaranteed to happen and will trigger entry to the default runlevel,
    and we don't care about ssh starting before the network (LP: #1098299).
  * Drop conffile handling for direct upgrades from pre-split ssh package;
    this was originally added in 1:4.3p2-7 / 1:4.3p2-8, and contained a
    truly ghastly hack around a misbehaviour in sarge's dpkg.  Since this is
    now four Debian releases ago, we can afford to drop this and simplify
    the packaging.
  * Remove ssh/use_old_init_script, which was a workaround for a very old
    bug in /etc/init.d/ssh.  If anyone has ignored this for >10 years then
    they aren't going to be convinced now (closes: #214182).
  * Remove support for upgrading directly from ssh-nonfree.
  * Remove lots of maintainer script support for direct upgrades from
    pre-etch (three releases before current stable).
  * Add #DEBHELPER# tokens to openssh-client.postinst and
    openssh-server.postinst.
  * Replace old manual conffile handling code with dpkg-maintscript-helper,
    via dh_installdeb.
  * Switch to new unified layout for Upstart jobs as documented in
    https://wiki.ubuntu.com/UpstartCompatibleInitScripts: the init script
    checks for a running Upstart, and we now let dh_installinit handle most
    of the heavy lifting in maintainer scripts.  Ubuntu users should be
    essentially unaffected except that sshd may no longer start
    automatically in chroots if the running Upstart predates 0.9.0; but the
    main goal is simply not to break when openssh-server is installed in a
    chroot.
  * Remove the check for vulnerable host keys; this was first added five
    years ago, and everyone should have upgraded through a version that
    applied these checks by now.  The ssh-vulnkey tool and the blacklisting
    support in sshd are still here, at least for the moment.
  * This removes the last of our uses of debconf (closes: #221531).
  * Use the pam_loginuid session module (thanks, Laurent Bigonville; closes:
    #677440, LP: #1067779).
  * Bracket our session stack with calls to pam_selinux close/open (thanks,
    Laurent Bigonville; closes: #679458).
  * Fix dh_builddeb invocation so that we really use xz compression for
    binary packages, as intended since 1:6.1p1-2.

 -- Colin Watson <cjwatson@debian.org>  Wed, 22 May 2013 09:07:42 +0100

openssh (1:6.2p2-1) unstable; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-6.2p2):
    - Only warn for missing identity files that were explicitly specified


=== debian/rules ===
--- 
+++ 
@@ -41,8 +41,9 @@
   endif
 endif
 
-# Change the version string to include the Debian version
-SSH_EXTRAVERSION := Debian-$(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/Version: //p' | sed -e 's/[^-]*-//')
+# Change the version string to reflect distribution
+DISTRIBUTION := $(shell dpkg-vendor --query vendor)
+SSH_EXTRAVERSION := $(DISTRIBUTION)-$(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/Version: //p' | sed -e 's/[^-]*-//')
 
 DISTRIBUTOR := $(shell if dpkg-vendor --derives-from Ubuntu 2>/dev/null; then echo Ubuntu; else echo Debian; fi)
 ifeq ($(DISTRIBUTOR),Ubuntu)
@@ -113,27 +114,20 @@
 confflags_udeb += --with-ldflags='-Wl,--as-needed'
 
 %:
-	dh $@
-
-DISTRIBUTOR_REPLACE := \
-	debian/openssh-server.if-up \
-	debian/openssh-server.ssh.init \
-	debian/openssh-server.postinst \
-	debian/openssh-server.prerm \
-	debian/ssh-krb5.postinst
-
-debian/%: debian/%.in
-	sed 's/@DISTRIBUTOR@/$(DISTRIBUTOR)/g' $< >$@
+	dh $@ --with=autoreconf
+
+autoreconf:
+	autoreconf -f -i
+	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub ./
+
+override_dh_autoreconf:
+	dh_autoreconf debian/rules -- autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -Bbuild-deb -- $(confflags)
 	dh_auto_configure -Bbuild-udeb -- $(confflags_udeb)
 
 override_dh_auto_build:
-	# Debian's /var/log/btmp has inappropriate permissions.
-	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' build-deb/config.h
-	perl -pi -e 's,.*#define USE_BTMP .*,/* #undef USE_BTMP */,' build-udeb/config.h
-
 	# Avoid libnsl linkage. Ugh.
 	perl -pi -e 's/ +-lnsl//' build-udeb/config.status
 	cd build-udeb && ./config.status
@@ -157,14 +151,10 @@
 	(cat debian/copyright.head; iconv -f ISO-8859-1 -t UTF-8 LICENCE) \
 		> debian/copyright
 
-override_dh_clean:
-	dh_clean
-	rm -f $(DISTRIBUTOR_REPLACE)
-
 override_dh_auto_install:
 	$(MAKE) -C build-deb DESTDIR=`pwd`/debian/tmp install-nokeys
 
-override_dh_install: $(DISTRIBUTOR_REPLACE)
+override_dh_install:
 	rm -f debian/tmp/etc/ssh/sshd_config
 
 	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb --fail-missing
@@ -187,6 +177,9 @@
 	install -p -m 644 debian/openssh-client.apport debian/openssh-client/usr/share/apport/package-hooks/openssh-client.py
 	install -p -m 644 debian/openssh-server.apport debian/openssh-server/usr/share/apport/package-hooks/openssh-server.py
 
+	# Upstart user job (only used under user sessions)
+	install -p -m 644 -D debian/ssh-agent.user-session.upstart debian/openssh-client/usr/share/upstart/sessions/ssh-agent.conf
+
 override_dh_installdocs:
 	dh_installdocs -Nopenssh-server -Nssh
 	dh_installdocs -popenssh-server -pssh --link-doc=openssh-client
@@ -194,13 +187,7 @@
 	mkdir -p debian/openssh-server/usr/share/doc/openssh-client
 
 override_dh_installinit:
-	dh_installinit -n --name ssh
-ifeq ($(DISTRIBUTOR),Ubuntu)
-	# We need to keep the init script as well as the Upstart job for
-	# now, for the benefit of people running sshd in chroots.
-	install -D -o root -g root debian/openssh-server.ssh.init debian/openssh-server/etc/init.d/ssh
-	install -D -o root -g root -m 644 debian/openssh-server.ssh.default debian/openssh-server/etc/default/ssh
-endif
+	dh_installinit -R --name ssh -- start 16 2 3 4 5 .
 
 override_dh_installpam:
 	dh_installpam --name sshd
@@ -214,23 +201,24 @@
 	dh_shlibdeps
 	debian/adjust-openssl-dependencies
 
-override_dh_installdeb: $(DISTRIBUTOR_REPLACE)
-	dh_installdeb
-	perl -i debian/substitute-conffile.pl \
-		ETC_SSH_MODULI debian/openssh-client/etc/ssh/moduli \
-		ETC_SSH_SSH_CONFIG debian/openssh-client/etc/ssh/ssh_config \
-		debian/openssh-client/DEBIAN/preinst
-	# Yes, ETC_PAM_D_SSH is meant to be spelled that way, to match the
-	# old configuration file name we need to transfer.
-	perl -i debian/substitute-conffile.pl \
-		ETC_DEFAULT_SSH debian/openssh-server/etc/default/ssh \
-		ETC_INIT_D_SSH debian/openssh-server/etc/init.d/ssh \
-		ETC_PAM_D_SSH debian/openssh-server/etc/pam.d/sshd \
-		debian/openssh-server/DEBIAN/preinst
-
 override_dh_gencontrol:
 	dh_gencontrol -- -V'openssh-server:Recommends=$(server_recommends)'
 
 override_dh_builddeb:
-	dh_builddeb -Zxz
-
+	dh_builddeb -- -Zxz
+
+debian/faq.html:
+	wget -O - http://www.openssh.org/faq.html | \
+		sed 's,\(href="\)\(txt/\|[^":]*\.html\),\1http://www.openssh.org/\2,g' \
+		> debian/faq.html
+
+# You only need to run this immediately after checking out the package from
+# revision control.
+quilt-setup:
+	[ ! -d .pc ]
+	set -e; for patch in $$(quilt series | tac); do \
+		patch -p1 -R --no-backup-if-mismatch <"debian/patches/$$patch"; \
+	done
+	quilt push -a
+
+.PHONY: quilt-setup

## openssh 6.6p1

=== contrib/Makefile ===
PKG_CONFIG = pkg-config

all:
	@echo "Valid targets: gnome-ssh-askpass1 gnome-ssh-askpass2"

gnome-ssh-askpass1: gnome-ssh-askpass1.c
	$(CC) `gnome-config --cflags gnome gnomeui` \
		gnome-ssh-askpass1.c -o gnome-ssh-askpass1 \
		`gnome-config --libs gnome gnomeui`

gnome-ssh-askpass2: gnome-ssh-askpass2.c
	$(CC) `$(PKG_CONFIG) --cflags gtk+-2.0` \
		gnome-ssh-askpass2.c -o gnome-ssh-askpass2 \
		`$(PKG_CONFIG) --libs gtk+-2.0 x11`

clean:
	rm -f *.o gnome-ssh-askpass1 gnome-ssh-askpass2 gnome-ssh-askpass

=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.68 2014/01/25 04:35:32 dtucker Exp $

REGRESS_TARGETS=	t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t-exec
tests:		$(REGRESS_TARGETS)

# Interop tests are not run by default
interop interop-tests: t-exec-interop

clean:
	for F in $(CLEANFILES); do rm -f $(OBJ)$$F; done
	test -z "${SUDO}" || ${SUDO} rm -f ${SUDO_CLEAN}
	rm -rf $(OBJ).putty

distclean:	clean

LTESTS= 	connect \
		proxy-connect \
		connect-privsep \
		proto-version \
		proto-mismatch \
		exit-status \
		envpass \
		transfer \
		banner \
		rekey \
		stderr-data \
		stderr-after-eof \
		broken-pipe \
		try-ciphers \
		yes-head \
		login-timeout \
		agent \
		agent-getpeereid \
		agent-timeout \
		agent-ptrace \
		keyscan \
		keygen-change \
		keygen-convert \
		key-options \
		scp \
		sftp \
		sftp-chroot \
		sftp-cmds \
		sftp-badcmds \
		sftp-batch \
		sftp-glob \
		sftp-perm \
		reconfigure \
		dynamic-forward \
		forwarding \
		multiplex \
		reexec \
		brokenkeys \
		cfgmatch \
		addrmatch \
		localcommand \
		forcecommand \
		portnum \
		keytype \
		kextype \
		cert-hostkey \
		cert-userkey \
		host-expand \
		keys-command \
		forward-control \
		integrity \
		krl
#		dhgex \

INTEROP_TESTS=	putty-transfer putty-ciphers putty-kex conch-ciphers
#INTEROP_TESTS+=ssh-com ssh-com-client ssh-com-keygen ssh-com-sftp

#LTESTS= 	cipher-speed

USER!=		id -un
CLEANFILES=	t2.out t3.out t6.out1 t6.out2 t7.out t7.out.pub copy.1 copy.2 \
		t8.out t8.out.pub t9.out t9.out.pub t10.out t10.out.pub \
		authorized_keys_${USER} known_hosts pidfile testdata \
		ssh_config sshd_config.orig ssh_proxy sshd_config sshd_proxy \
		rsa.pub rsa rsa1.pub rsa1 host.rsa host.rsa1 \
		rsa-agent rsa-agent.pub rsa1-agent rsa1-agent.pub \
		ls.copy banner.in banner.out empty.in \
		scp-ssh-wrapper.scp ssh_proxy_envpass remote_pid \
		sshd_proxy_bak rsa_ssh2_cr.prv rsa_ssh2_crnl.prv \
		known_hosts-cert host_ca_key* cert_host_key* cert_user_key* \
		putty.rsa2 sshd_proxy_orig ssh_proxy_bak \
		key.rsa-* key.dsa-* key.ecdsa-* \
		authorized_principals_${USER} expect actual ready \
		sshd_proxy.* authorized_keys_${USER}.* modpipe revoked-* krl-* \
		ssh.log failed-ssh.log sshd.log failed-sshd.log \
		regress.log failed-regress.log ssh-log-wrapper.sh \
		sftp-server.sh sftp-server.log sftp.log setuid-allowed \
		data ed25519-agent ed25519-agent.pub key.ed25519-512 \
		key.ed25519-512.pub

SUDO_CLEAN+=	/var/run/testdata_${USER} /var/run/keycommand_${USER}

# Enable all malloc(3) randomisations and checks
TEST_ENV=      "MALLOC_OPTIONS=AFGJPRX"

TEST_SSH_SSHKEYGEN?=ssh-keygen

CPPFLAGS=-I..

t1:
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/rsa_ssh2.prv | diff - ${.CURDIR}/rsa_openssh.prv
	tr '\n' '\r' <${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_cr.prv
	${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_cr.prv | diff - ${.CURDIR}/rsa_openssh.prv
	awk '{print $$0 "\r"}' ${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_crnl.prv
	${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_crnl.prv | diff - ${.CURDIR}/rsa_openssh.prv

t2:
	cat ${.CURDIR}/rsa_openssh.prv > $(OBJ)/t2.out
	chmod 600 $(OBJ)/t2.out
	${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t2.out | diff - ${.CURDIR}/rsa_openssh.pub

t3:
	${TEST_SSH_SSHKEYGEN} -ef ${.CURDIR}/rsa_openssh.pub >$(OBJ)/t3.out
	${TEST_SSH_SSHKEYGEN} -if $(OBJ)/t3.out | diff - ${.CURDIR}/rsa_openssh.pub

t4:
	${TEST_SSH_SSHKEYGEN} -lf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t4.ok

t5:
	${TEST_SSH_SSHKEYGEN} -Bf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t5.ok

t6:
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/dsa_ssh2.prv > $(OBJ)/t6.out1
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/dsa_ssh2.pub > $(OBJ)/t6.out2
	chmod 600 $(OBJ)/t6.out1
	${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t6.out1 | diff - $(OBJ)/t6.out2

$(OBJ)/t7.out:
	${TEST_SSH_SSHKEYGEN} -q -t rsa -N '' -f $@

t7: $(OBJ)/t7.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t7.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t7.out > /dev/null

$(OBJ)/t8.out:
	${TEST_SSH_SSHKEYGEN} -q -t dsa -N '' -f $@

t8: $(OBJ)/t8.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t8.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t8.out > /dev/null

$(OBJ)/t9.out:
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -q -t ecdsa -N '' -f $@

t9: $(OBJ)/t9.out
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t9.out > /dev/null
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t9.out > /dev/null


$(OBJ)/t10.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -f $@

t10: $(OBJ)/t10.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t10.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t10.out > /dev/null

t-exec:	${LTESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

t-exec-interop:	${INTEROP_TESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

# Not run by default
interop: ${INTEROP_TARGETS}

=== debian/changelog ===
openssh (1:6.6p1-2ubuntu2.13) trusty-security; urgency=medium

  * SECURITY UPDATE: Incomplete fix for CVE-2019-6111
    - debian/patches/CVE-2019-6111-pre1.patch: add reallocarray to
      openbsd-compat/Makefile.in, openbsd-compat/openbsd-compat.h,
      openbsd-compat/reallocarray.c.
    - debian/patches/CVE-2019-6111-2.patch: add another fix to the filename
      check in scp.c.
    - CVE-2019-6111
  * Fixed inverted CVE numbers in patch filenames and in previous
    changelog.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 04 Mar 2019 07:52:28 -0500

openssh (1:6.6p1-2ubuntu2.12) trusty-security; urgency=medium

  * SECURITY UPDATE: access restrictions bypass in scp
    - debian/patches/CVE-2018-20685.patch: disallow empty filenames
      or ones that refer to the current directory in scp.c.
    - CVE-2018-20685
  * SECURITY UPDATE: scp client spoofing via object name
    - debian/patches/CVE-2019-6111.patch: make sure the filenames match
      the wildcard specified by the user, and add new flag to relax the new
      restrictions in scp.c, scp.1.
    - CVE-2019-6111
  * SECURITY UPDATE: scp client missing received object name validation
    - debian/patches/CVE-2019-6109-pre1.patch: backport snmprintf from
      newer OpenSSH in Makefile.in, utf8.c, utf8.h, configure.ac.
    - debian/patches/CVE-2019-6109-pre2.patch: update vis.h and vis.c from
      newer OpenSSH.
    - debian/patches/CVE-2019-6109-1.patch: sanitize scp filenames via
      snmprintf in atomicio.c, progressmeter.c, progressmeter.h,
      scp.c, sftp-client.c.
    - debian/patches/CVE-2019-6109-2.patch: force progressmeter updates in
      progressmeter.c, progressmeter.h, scp.c, sftp-client.c.
    - CVE-2019-6109

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 31 Jan 2019 11:18:29 -0500

openssh (1:6.6p1-2ubuntu2.11) trusty-security; urgency=medium

  * SECURITY UPDATE: OpenSSH User Enumeration Vulnerability (LP: #1794629)
    - debian/patches/CVE-2018-15473.patch: delay bailout for invalid
      authenticating user until after the packet containing the request
      has been fully parsed.
    - CVE-2018-15473
  [ Leonidas S. Barbosa ]
  * SECURITY UPDATE: Privsep process chrashing via an out-of-sequence
    - debian/patches/CVE-2016-10708.patch: fix in kex.c,
      pack.c.
    - CVE-2016-10708

 -- Ryan Finnie <ryan@finnie.org>  Sat, 13 Oct 2018 23:31:08 +0000

openssh (1:6.6p1-2ubuntu2.10) trusty-security; urgency=medium

  * SECURITY UPDATE: untrusted search path when loading PKCS#11 modules
    - debian/patches/CVE-2016-10009.patch: add a whitelist of paths from
      which ssh-agent will load a PKCS#11 module in ssh-agent.1,
      ssh-agent.c.
    - debian/patches/CVE-2016-10009-2.patch: fix deletion of PKCS#11 keys
      in ssh-agent.c.
    - debian/patches/CVE-2016-10009-3.patch: relax whitelist in
      ssh-agent.c.
    - debian/patches/CVE-2016-10009-4.patch: add missing label in
      ssh-agent.c.
    - CVE-2016-10009
  * SECURITY UPDATE: local information disclosure via effects of realloc on
    buffer contents
    - debian/patches/CVE-2016-10011.patch: pre-allocate the buffer used for
      loading keys in authfile.c.
    - CVE-2016-10011
  * SECURITY UPDATE: local privilege escalation via incorrect bounds check
    in shared memory manager
    - debian/patches/CVE-2016-10012-1-2.patch: remove support for
      pre-authentication compression in kex.c, kex.h, Makefile.in,
      monitor.c, monitor.h, monitor_wrap.c, monitor_wrap.h, myproposal.h,
      packet.c, servconf.c, sshd.c, sshd_config.5.
    - debian/patches/CVE-2016-10012-3.patch: put back some pre-auth zlib
      bits in kex.c, kex.h, packet.c.
    - CVE-2016-10012
  * SECURITY UPDATE: DoS via zero-length file creation in readonly mode
    - debian/patches/CVE-2017-15906.patch: disallow creation of empty files
      in sftp-server.c.
    - CVE-2017-15906

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 15 Jan 2018 11:28:55 -0500

openssh (1:6.6p1-2ubuntu2.8) trusty-security; urgency=medium

  * SECURITY UPDATE: user enumeration via covert timing channel
    - debian/patches/CVE-2016-6210-1.patch: determine appropriate salt for
      invalid users in auth-passwd.c, openbsd-compat/xcrypt.c.
    - debian/patches/CVE-2016-6210-2.patch: mitigate timing of disallowed
      users PAM logins in auth-pam.c.
    - debian/patches/CVE-2016-6210-3.patch: search users for one with a
      valid salt in openbsd-compat/xcrypt.c.
    - CVE-2016-6210
  * SECURITY UPDATE: denial of service via long passwords
    - debian/patches/CVE-2016-6515.patch: skip passwords longer than 1k in
      length in auth-passwd.c.
    - CVE-2016-6515

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 11 Aug 2016 08:43:06 -0400

openssh (1:6.6p1-2ubuntu2.7) trusty-security; urgency=medium

  * SECURITY UPDATE: privilege escalation via environment files when
    UseLogin is configured
    - debian/patches/CVE-2015-8325.patch: ignore PAM environment vars when
      UseLogin is enabled in session.c.
    - CVE-2015-8325
  * SECURITY UPDATE: fallback from untrusted X11-forwarding to trusted
    - debian/patches/CVE-2016-1908-1.patch: use stack memory in
      clientloop.c.
    - debian/patches/CVE-2016-1908-2.patch: eliminate fallback in
      clientloop.c, clientloop.h, mux.c, ssh.c.
    - CVE-2016-1908
  * SECURITY UPDATE: shell-command restrictions bypass via crafted X11
    forwarding data
    - debian/patches/CVE-2016-3115.patch: sanitise characters destined for
      xauth in session.c.
    - CVE-2016-3115

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 05 May 2016 08:29:07 -0400

openssh (1:6.6p1-2ubuntu2.6) trusty; urgency=medium

  * debian/control, debian/rules: enable libaudit support. (LP: #1478087)

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 26 Jan 2016 10:38:35 -0500

openssh (1:6.6p1-2ubuntu2.5) trusty-proposed; urgency=medium

  * Backport upstream reporting of max auth attempts, so that fail2bail


=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: openssh
 Section: net
 Priority: standard
-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
-Build-Depends: libwrap0-dev | libwrap-dev, zlib1g-dev (>= 1:1.2.3-1), libssl-dev (>= 0.9.8g), libpam0g-dev | libpam-dev, libgtk2.0-dev, libedit-dev, debhelper (>= 7.4.2~), libselinux1-dev [linux-any], libkrb5-dev | heimdal-dev, dpkg (>= 1.16.1~), libck-connector-dev
-Standards-Version: 3.8.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
+Build-Depends: libwrap0-dev | libwrap-dev, zlib1g-dev (>= 1:1.2.3), libssl-dev (>= 0.9.8g), libpam0g-dev | libpam-dev, libgtk2.0-dev, libedit-dev, debhelper (>= 8.1.0~), libselinux1-dev [linux-any], libkrb5-dev | heimdal-dev, dpkg (>= 1.16.1~), libck-connector-dev, dh-autoreconf, autotools-dev, dh-systemd (>= 1.4), libaudit-dev [linux-any]
+Standards-Version: 3.9.5
 Uploaders: Colin Watson <cjwatson@debian.org>, Matthew Vernon <matthew@debian.org>
 Homepage: http://www.openssh.org/
-Vcs-Bzr: http://anonscm.debian.org/bzr/pkg-ssh/openssh/trunk
-Vcs-Browser: http://anonscm.debian.org/loggerhead/pkg-ssh/openssh/trunk
+Vcs-Git: git://anonscm.debian.org/pkg-ssh/openssh.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ssh/openssh.git
 
 Package: openssh-client
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 1.2.0) | debconf-2.0, adduser (>= 3.10), dpkg (>= 1.7.0), passwd
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser (>= 3.10), dpkg (>= 1.7.0), passwd
 Recommends: xauth
-Conflicts: ssh (<< 1:3.8.1p1-9), sftp, rsh-client (<<0.16.1-1), ssh-krb5 (<< 1:4.3p2-7)
+Conflicts: sftp
 Replaces: ssh, ssh-krb5
-Suggests: ssh-askpass, libpam-ssh, keychain, monkeysphere, openssh-blacklist, openssh-blacklist-extra
+Suggests: ssh-askpass, libpam-ssh, keychain, monkeysphere
 Provides: rsh-client, ssh-client
 Multi-Arch: foreign
 Description: secure shell (SSH) client, for secure access to remote machines
@@ -44,11 +45,12 @@
 Package: openssh-server
 Priority: optional
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 1.2.0) | debconf-2.0, libpam-runtime (>= 0.76-14), libpam-modules (>= 0.72-9), adduser (>= 3.9), dpkg (>= 1.9.0), openssh-client (= ${binary:Version}), lsb-base (>= 3.2-13), procps, debianutils (>= 4)
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, libpam-runtime (>= 0.76-14), libpam-modules (>= 0.72-9), adduser (>= 3.9), dpkg (>= 1.9.0), openssh-client (= ${binary:Version}), lsb-base (>= 4.1+Debian3), procps, openssh-sftp-server
 Recommends: xauth, ncurses-term, ${openssh-server:Recommends}
-Conflicts: ssh (<< 1:3.8.1p1-9), ssh-nonfree (<<2), ssh-socks, ssh2, sftp, rsh-client (<<0.16.1-1), ssh-krb5 (<< 1:4.3p2-7)
-Replaces: ssh, openssh-client (<< 1:3.8.1p1-11), ssh-krb5
-Suggests: ssh-askpass, rssh, molly-guard, ufw, monkeysphere, openssh-blacklist, openssh-blacklist-extra
+Conflicts: ssh-socks, ssh2, sftp
+Replaces: ssh, ssh-krb5
+Suggests: ssh-askpass, rssh, molly-guard, ufw, monkeysphere
 Provides: ssh-server
 Multi-Arch: foreign
 Description: secure shell (SSH) server, for secure access from remote machines
@@ -71,6 +73,31 @@
  .
  sshd replaces the insecure rshd program, which is obsolete for most
  purposes.
+
+Package: openssh-sftp-server
+Priority: optional
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: openssh-server | ssh-server
+Breaks: openssh-server (<< 1:6.5p1-5)
+Replaces: openssh-server (<< 1:6.5p1-5)
+Enhances: openssh-server, ssh-server
+Description: secure shell (SSH) sftp server module, for SFTP access from remote machines
+ This is the portable version of OpenSSH, a free implementation of
+ the Secure Shell protocol as specified by the IETF secsh working
+ group.
+ .
+ Ssh (Secure Shell) is a program for logging into a remote machine
+ and for executing commands on a remote machine.
+ It provides secure encrypted communications between two untrusted
+ hosts over an insecure network. X11 connections and arbitrary TCP/IP
+ ports can also be forwarded over the secure channel.
+ It can be used to provide applications with a secure communication
+ channel.
+ .
+ This package provides the SFTP server module for the SSH server. It
+ is needed if you want to access your SSH server with SFTP. The SFTP
+ server module also works with other SSH daemons like dropbear.
 
 Package: ssh
 Priority: extra

=== debian/rules ===
--- 
+++ 
@@ -47,11 +47,11 @@
 
 DISTRIBUTOR := $(shell if dpkg-vendor --derives-from Ubuntu 2>/dev/null; then echo Ubuntu; else echo Debian; fi)
 ifeq ($(DISTRIBUTOR),Ubuntu)
-DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11:/usr/games
-else
-DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/bin/X11:/usr/games
-endif
-SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11
+DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
+else
+DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/games
+endif
+SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
 
 ifeq ($(DISTRIBUTOR),Ubuntu)
 server_recommends := ssh-import-id
@@ -71,6 +71,11 @@
 # The Hurd needs libcrypt for res_query et al.
 ifeq ($(DEB_HOST_ARCH_OS),hurd)
 confflags += --with-libs=-lcrypt
+endif
+
+# http://gcc.gnu.org/bugzilla/show_bug.cgi?id=60155
+ifeq ($(DEB_HOST_ARCH),hppa)
+confflags += --without-hardening
 endif
 
 # Everything above here is common to the deb and udeb builds.
@@ -84,6 +89,7 @@
 confflags += --with-ssl-engine
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 confflags += --with-selinux
+confflags += --with-audit=linux
 endif
 ifeq ($(DISTRIBUTOR),Ubuntu)
 confflags += --with-consolekit
@@ -93,7 +99,7 @@
 confflags += --with-xauth=/usr/bin/xauth
 confflags_udeb += --without-xauth
 
-# Default paths. The udeb build has /usr/bin/X11 and /usr/games removed.
+# Default paths. The udeb build has /usr/games removed.
 confflags += --with-default-path=$(DEFAULT_PATH) --with-superuser-path=$(SUPERUSER_PATH)
 confflags_udeb += --with-default-path=/usr/local/bin:/usr/bin:/bin --with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
 
@@ -114,7 +120,7 @@
 confflags_udeb += --with-ldflags='-Wl,--as-needed'
 
 %:
-	dh $@ --with=autoreconf
+	dh $@ --with=autoreconf,systemd
 
 autoreconf:
 	autoreconf -f -i
@@ -181,13 +187,18 @@
 	install -p -m 644 -D debian/ssh-agent.user-session.upstart debian/openssh-client/usr/share/upstart/sessions/ssh-agent.conf
 
 override_dh_installdocs:
-	dh_installdocs -Nopenssh-server -Nssh
-	dh_installdocs -popenssh-server -pssh --link-doc=openssh-client
+	dh_installdocs -Nopenssh-server -Nopenssh-sftp-server -Nssh
+	dh_installdocs -popenssh-server -popenssh-sftp-server -pssh \
+		--link-doc=openssh-client
 	# Avoid breaking dh_installexamples later.
 	mkdir -p debian/openssh-server/usr/share/doc/openssh-client
 
+override_dh_systemd_enable:
+	dh_systemd_enable -popenssh-server --name ssh ssh.service
+	dh_systemd_enable -popenssh-server --name ssh --no-enable ssh.socket
+
 override_dh_installinit:
-	dh_installinit -R --name ssh -- start 16 2 3 4 5 .
+	dh_installinit -R --name ssh
 
 override_dh_installpam:
 	dh_installpam --name sshd
@@ -211,14 +222,3 @@
 	wget -O - http://www.openssh.org/faq.html | \
 		sed 's,\(href="\)\(txt/\|[^":]*\.html\),\1http://www.openssh.org/\2,g' \
 		> debian/faq.html
-
-# You only need to run this immediately after checking out the package from
-# revision control.
-quilt-setup:
-	[ ! -d .pc ]
-	set -e; for patch in $$(quilt series | tac); do \
-		patch -p1 -R --no-backup-if-mismatch <"debian/patches/$$patch"; \
-	done
-	quilt push -a
-
-.PHONY: quilt-setup

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-(.*)\.tar\.gz
